Index: /trunk/SophyaPI/PI/Tests/pitcons.cc
===================================================================
--- /trunk/SophyaPI/PI/Tests/pitcons.cc	(revision 1073)
+++ /trunk/SophyaPI/PI/Tests/pitcons.cc	(revision 1074)
@@ -102,6 +102,10 @@
 PITApp::~PITApp()
 {
+  MainWin()->Hide();  // Pb de plantage de ~PIConsole(), delete mScb , 07/2000
+  //  cerr << " Deleting scons ... \n " << endl;
   if (scons) delete scons;
+  //  cerr << " Deleting cons ... \n " << endl;
   if (cons) delete cons;
+  //  cerr << " end of  PITApp::~PITApp()... \n " << endl;
 }  
 
Index: /trunk/SophyaPI/PI/piapplx.cc
===================================================================
--- /trunk/SophyaPI/PI/piapplx.cc	(revision 1073)
+++ /trunk/SophyaPI/PI/piapplx.cc	(revision 1074)
@@ -1,4 +1,5 @@
 #include <stdio.h>
 #include <X11/cursorfont.h>
+#include <X11/IntrinsicP.h>
 #include "piapplx.h"
 #include "picontainerx.h"
@@ -42,4 +43,5 @@
 };
 
+
 /* --Methode-- */
 PITopContAppX::PITopContAppX(PIContainer *par, char *nom, PIWdg* topw, int sx, int sy, int px, int py)
@@ -59,10 +61,22 @@
 {
 if ((sx <10) || (sy < 10) ) return; 
+
+int px = XPos();
+int py = YPos();
 #if !defined(SunOS)
 // Probleme sur Sun - Reza 10/99
-mTopWdg->SetSize(sx+XPos(), sy+YPos());
-#endif
-Parent()->SetSize(sx+XPos(), sy+YPos());
+mTopWdg->SetSize(sx+px, sy+py);
+#endif
+
+XtConfigureWidget(Parent()->XtWdg(),  0, 0, sx+px, sy+py, 0);
+
+// Parent()->SetPos(0, 0);
+// Parent()->SetSize(sx+px, sy+py);
 // PIContainer::SetSize(sx, sy);   Probleme sur Sun - Reza 9/08/99
+
+XtConfigureWidget(XtWdg(),  px, py, sx, sy, 0);
+
+// SetPos(px, py);
+// PIContainer::SetSize(sx, sy); 
 }
 
@@ -112,5 +126,5 @@
 MBCont()->Show();
 //DBG printf("PIApplicationX-DBG2:: MBContSize=%d %d \n", MBCont()->XSize(), MBCont()->YSize());
-//DBG printf("PIApplicationX-DBG2:: topcontSize=%d %d \n", MainWin()->XSize(), MainWin()->YSize());
+
 
 topcont->Show();
@@ -164,5 +178,6 @@
 // Pour appeler FinishCreate() des objets dans la fenetre principale 
 if (mStop) { // C'est la premiere fois
-  topwdg->SetSize(MBCont()->XSize(), MBCont()->YSize());
+  topcont->SetSize(topcont->XSize(), topcont->YSize());
+  // topwdg->SetSize(MBCont()->XSize(), MBCont()->YSize());
   MBCont()->FinishCreate();   
   }
Index: /trunk/SophyaPI/PI/picontainerx.cc
===================================================================
--- /trunk/SophyaPI/PI/picontainerx.cc	(revision 1073)
+++ /trunk/SophyaPI/PI/picontainerx.cc	(revision 1074)
@@ -17,7 +17,9 @@
   CreateXtWdg(nom, xmFormWidgetClass , NULL, sx, sy, px, py);
   int fbase = PIXMFORMFRACBASE ;  // Valeur de XmNfractionBase des XmForm ds PIContainerX
-  Arg  wargs[2];
+  Arg  wargs[5];
   int n=0;
   XtSetArg(wargs[n],XmNfractionBase, fbase);  n++;
+  XtSetArg(wargs[n],XmNhorizontalSpacing, 0);  n++;
+  XtSetArg(wargs[n],XmNverticalSpacing, 0);  n++;
   XtSetValues(XtWdg(), wargs, n);
   }
@@ -35,7 +37,9 @@
   CreateXtWdg(nom, xmFormWidgetClass , parwdg->XtWdg(), sx, sy, px, py);
   int fbase = PIXMFORMFRACBASE ;  // Valeur de XmNfractionBase des XmForm ds PIContainerX
-  Arg  wargs[2];
+  Arg  wargs[5];
   int n=0;
   XtSetArg(wargs[n],XmNfractionBase, fbase);  n++;
+  XtSetArg(wargs[n],XmNhorizontalSpacing, 0);  n++;
+  XtSetArg(wargs[n],XmNverticalSpacing, 0);  n++;
   XtSetValues(XtWdg(), wargs, n);
   }
Index: /trunk/SophyaPI/PI/piwdgx.cc
===================================================================
--- /trunk/SophyaPI/PI/piwdgx.cc	(revision 1073)
+++ /trunk/SophyaPI/PI/piwdgx.cc	(revision 1074)
@@ -398,5 +398,5 @@
 int frpos = 0;
 float frac;
-Arg  wargs[9];
+Arg  wargs[13];
 int n=0;
 
@@ -417,4 +417,5 @@
     frpos = frac*fbase;
     XtSetArg(wargs[n],XmNleftPosition, frpos );  n++;
+    XtSetArg(wargs[n],XmNleftOffset, 0 );  n++;
     break;
   default :
@@ -438,4 +439,5 @@
     frpos = frac*fbase;
     XtSetArg(wargs[n],XmNtopPosition, frpos );  n++;
+    XtSetArg(wargs[n],XmNtopOffset, 0 );  n++;
     break;
   default :
@@ -459,4 +461,5 @@
     frpos = frac*fbase;
     XtSetArg(wargs[n],XmNrightPosition, frpos );  n++;
+    XtSetArg(wargs[n],XmNrightOffset, 0 );  n++;
     break;
   default : 
@@ -481,4 +484,5 @@
     frpos = frac*fbase;
     XtSetArg(wargs[n],XmNbottomPosition, frpos );  n++;
+    XtSetArg(wargs[n],XmNbottomOffset, 0 );  n++;
     break;
   default :