Index: trunk/SophyaPI/PIext/pawexecut.cc
===================================================================
--- trunk/SophyaPI/PIext/pawexecut.cc	(revision 1090)
+++ trunk/SophyaPI/PIext/pawexecut.cc	(revision 1091)
@@ -368,5 +368,5 @@
   {cout<<"PAWExecutor::h_integ Error: unknow object"<<tokens[0]<<endl;
   return;}
-double norm = 1.;
+r_8 norm = 1.;
 if(tokens.size()>=2) norm = atof(tokens[1].c_str());
 // attention: dynamic_cast<Histo*>(HProf)=Vrai!
@@ -410,5 +410,5 @@
   {cout<<"PAWExecutor::h_rebin Error: unknow object"<<tokens[0]<<endl;
   return;}
-int nbin = atoi(tokens[1].c_str());
+int_4 nbin = atoi(tokens[1].c_str());
 Histo* h1 = dynamic_cast<Histo*>(mobj);
 // Ca marche aussi pour les HProf, HRebin a ete passe virtuel
@@ -431,5 +431,5 @@
   {cout<<"PAWExecutor::h_cadd Error: unknow object"<<tokens[0]<<endl;
   return;}
-double val = atof(tokens[1].c_str());
+r_8 val = atof(tokens[1].c_str());
 Histo*   h1 = dynamic_cast<Histo*>(mobj);
 HProf*   hp = dynamic_cast<HProf*>(mobj);
@@ -455,5 +455,5 @@
   {cout<<"PAWExecutor::h_cmult Error: unknow object"<<tokens[0]<<endl;
   return;}
-double val = atof(tokens[1].c_str());
+r_8 val = atof(tokens[1].c_str());
 Histo*   h1 = dynamic_cast<Histo*>(mobj);
 HProf*   hp = dynamic_cast<HProf*>(mobj);
@@ -703,5 +703,5 @@
   if(tokens.size()<3)
     {cout<<"Usage: h/plot/2d nameh2d bx/by/sx/sy n [dopt]"<<endl; return;}
-  int n = atoi(tokens[2].c_str());
+  int_4 n = atoi(tokens[2].c_str());
   dopt = ""; if(tokens.size()>=4) dopt = tokens[3];
   if(proj == "bx") {
@@ -848,5 +848,5 @@
    return;}
 string proj = "h";  if(tokens.size()>3) proj = tokens[3];
-int nproj = -1;     if(tokens.size()>4) nproj = atoi(tokens[4].c_str());
+int_4 nproj = -1;   if(tokens.size()>4) nproj = atoi(tokens[4].c_str());
 string hname = tokens[0];
 string vname = tokens[1];
@@ -988,5 +988,5 @@
   Histo* v2 = NULL;
   if(mobjv2==NULL)
-    {v2 = new Histo(0.,(float)(i2-i1+1),i2-i1+1);
+    {v2 = new Histo(0.,(r_8)(i2-i1+1),i2-i1+1);
      omg.AddObj(v2,tokens[1]); mobjv2 = omg.GetObj(tokens[1]);}
   if(typeid(*mobjv2) != typeid(Histo))
@@ -1050,5 +1050,5 @@
   Histo2D* v2 = NULL;
   if(mobjv2==NULL)
-    {v2 = new Histo2D(0.,(float)(i2-i1+1),i2-i1+1,0.,(float)(j2-j1+1),j2-j1+1);
+    {v2 = new Histo2D(0.,(r_8)(i2-i1+1),i2-i1+1,0.,(r_8)(j2-j1+1),j2-j1+1);
      omg.AddObj(v2,tokens[1]); mobjv2 = omg.GetObj(tokens[1]);}
   if(typeid(*mobjv2) != typeid(Histo2D))
@@ -1096,8 +1096,8 @@
 // Decodage arguments
 bool replerr = false; if(dum=="err") replerr = true;
-float setval = (float) atof(tokens[1].c_str());
+r_8 setval = atof(tokens[1].c_str());
 int testcont=0; if(tokens[2]=="v") testcont=1; if(tokens[2]=="e") testcont=2;
 int_4 i1=-1, i2=-1, j1=-1, j2=-1;
-float v1=0., v2=0.;
+r_8 v1=0., v2=0.;
 if(testcont==0) {
   sscanf(tokens[2].c_str(),"%d:%d",&i1,&i2);
@@ -1107,5 +1107,5 @@
     {cout<<"PAWExecutor::h_set Error: h/set/... v v1:v2, please give v1:v2"<<endl;
     return;}
-  sscanf(tokens[3].c_str(),"%f:%f",&v1,&v2);
+  sscanf(tokens[3].c_str(),"%lf:%lf",&v1,&v2);
 }
 
@@ -1130,5 +1130,5 @@
     {cout<<"PAWExecutor::h_set Error: bad bin range i1="<<i1<<endl; return;}
   if(i2<i1) i2=i1; if(i2>=h->NBins()) i2=h->NBins()-1;
-  for(int i=i1;i<=i2;i++) {
+  for(int_4 i=i1;i<=i2;i++) {
     bool change = true;
     if(testcont==1) {if((*h)(i)<v1 || (*h)(i)>v2) change = false;}
@@ -1147,5 +1147,5 @@
   if(i2<i1) i2=i1; if(i2>=h2->NBinX()) i2=h2->NBinX()-1;
   if(j2<j1) j2=j1; if(j2>=h2->NBinY()) j2=h2->NBinY()-1;
-  for(int i=i1;i<=i2;i++) for(int j=j1;j<=j2;j++) {
+  for(int_4 i=i1;i<=i2;i++) for(int_4 j=j1;j<=j2;j++) {
     bool change = true;
     if(testcont==1) {if((*h2)(i,j)<v1 || (*h2)(i,j)>v2) change = false;}
@@ -1201,7 +1201,7 @@
   Histo* h  = dynamic_cast<Histo*>(mobj);
   if(!(h->HasErrors())) h->Errors();
-  for(int i=0;i<h->NBins();i++) {
-    double x = (double) (*h)(i);
-    double e = f(x);
+  for(int_4 i=0;i<h->NBins();i++) {
+    r_8 x = (*h)(i);
+    r_8 e = f(x);
     h->SetErr2(i,e*e); 
   }
@@ -1210,7 +1210,7 @@
   Histo2D* h2 = dynamic_cast<Histo2D*>(mobj);
   if(!(h2->HasErrors())) h2->Errors();
-  for(int i=0;i<h2->NBinX();i++) for(int j=0;j<h2->NBinY();j++) {
-    double x = (double) (*h2)(i,j);
-    double e = f(x);
+  for(int_4 i=0;i<h2->NBinX();i++) for(int_4 j=0;j<h2->NBinY();j++) {
+    r_8 x = (*h2)(i,j);
+    r_8 e = f(x);
     h2->Error2(i,j) = e*e; 
   }